# Product

Resource 'Product' operations.

## List all products

> Returns a list of products. The products are returned in descending order by creation date.

```json
{"openapi":"3.1.0","info":{"title":"Glu","version":"1.0.0"},"tags":[{"name":"Product","description":"Resource 'Product' operations."}],"servers":[{"url":"https://api.glu.io","description":"Production API"}],"security":[{"x_api_key":[]}],"components":{"securitySchemes":{"x_api_key":{"type":"apiKey","description":"Value for the x-api-key header parameter.","name":"x-api-key","in":"header"}},"schemas":{"Product-product.read":{"type":"object","properties":{"id":{"readOnly":true,"type":"integer"},"uuid":{"type":"string","format":"uuid"},"name":{"type":"string"},"type":{"type":"string","enum":["Voucher","Physical","RecurringProduct","ReferralProgram"]},"createdAt":{"type":"string","format":"date-time"},"updatedAt":{"type":"string","format":"date-time"},"description":{"default":"","type":["string","null"]},"status":{"default":"Active","type":"string","enum":["Draft","Active","Scheduled","Expired","Deleted"]},"permalink":{"type":"string"},"images":{"type":"array","items":{"type":["string","null"]}},"store":{"type":"integer"},"productTypePhysical":{"anyOf":[{"$ref":"#/components/schemas/ProductTypePhysical-product.read"},{"type":"null"}]},"voucher":{"anyOf":[{"$ref":"#/components/schemas/Voucher-product.read"},{"type":"null"}]},"referralProgram":{"type":["string","null"],"format":"iri-reference"},"productConfigurableOptions":{"type":"array","items":{"$ref":"#/components/schemas/ProductConfigurableOption-product.read"}},"PriceSuffix":{"default":"","type":"string"},"bundle":{"anyOf":[{"$ref":"#/components/schemas/Bundle-product.read"},{"type":"null"}]},"scheduledFrom":{"type":["string","null"],"format":"date-time"},"scheduledTo":{"type":["string","null"],"format":"date-time"},"codes":{"type":"array","items":{"$ref":"#/components/schemas/Code-product.read"}},"variants":{"type":"array","items":{"type":"integer"}},"deleted":{"default":false,"type":"boolean"},"deletedAt":{"type":["string","null"],"format":"date-time"},"location":{"type":"array","items":{"$ref":"#/components/schemas/Location-product.read"}},"allLocations":{"default":true,"type":"boolean"},"visibility":{"default":"Public","type":"string","enum":["Public","Direct Link"]},"recurringProduct":{"anyOf":[{"$ref":"#/components/schemas/RecurringProduct-product.read"},{"type":"null"}]},"productCategories":{"type":"array","items":{"$ref":"#/components/schemas/ProductCategory-product.read"}},"minimumPricing":{"type":"array","items":{"$ref":"#/components/schemas/ProductMinimumPrice-product.read"}}}},"ProductTypePhysical-product.read":{"type":"object"},"Voucher-product.read":{"type":"object"},"ProductConfigurableOption-product.read":{"type":"object"},"Bundle-product.read":{"type":"object"},"Code-product.read":{"type":"object"},"Location-product.read":{"type":"object"},"RecurringProduct-product.read":{"type":"object"},"ProductCategory-product.read":{"type":"object"},"ProductMinimumPrice-product.read":{"type":"object"},"Error.jsonld":{"type":"object","description":"A representation of common errors.","properties":{"title":{"readOnly":true,"description":"A short, human-readable summary of the problem.","type":["string","null"]},"detail":{"readOnly":true,"description":"A human-readable explanation specific to this occurrence of the problem.","type":["string","null"]},"status":{"type":["number","null"],"default":400},"instance":{"readOnly":true,"description":"A URI reference that identifies the specific occurrence of the problem. It may or may not yield further information if dereferenced.","type":["string","null"]},"type":{"readOnly":true,"description":"A URI reference that identifies the problem type","type":"string"},"description":{"readOnly":true,"type":["string","null"]}}},"Error":{"type":"object","description":"A representation of common errors.","properties":{"title":{"readOnly":true,"description":"A short, human-readable summary of the problem.","type":["string","null"]},"detail":{"readOnly":true,"description":"A human-readable explanation specific to this occurrence of the problem.","type":["string","null"]},"status":{"type":["number","null"],"default":400},"instance":{"readOnly":true,"description":"A URI reference that identifies the specific occurrence of the problem. It may or may not yield further information if dereferenced.","type":["string","null"]},"type":{"readOnly":true,"description":"A URI reference that identifies the problem type","type":"string"}}}}},"paths":{"/products":{"get":{"operationId":"api_products_get_collection","tags":["Product"],"responses":{"200":{"description":"Product collection","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Product-product.read"}}}}},"403":{"description":"Forbidden","content":{"application/ld+json":{"schema":{"$ref":"#/components/schemas/Error.jsonld"}},"application/problem+json":{"schema":{"$ref":"#/components/schemas/Error"}},"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"links":{}}},"summary":"List all products","description":"Returns a list of products. The products are returned in descending order by creation date.","parameters":[{"name":"page","in":"query","description":"The collection page number","required":false,"deprecated":false,"schema":{"type":"integer","default":1},"style":"form","explode":true},{"name":"createdAt[before]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"createdAt[strictly_before]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"createdAt[after]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"createdAt[strictly_after]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"updatedAt[before]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"updatedAt[strictly_before]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"updatedAt[after]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"updatedAt[strictly_after]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"scheduledFrom[before]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"scheduledFrom[strictly_before]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"scheduledFrom[after]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"scheduledFrom[strictly_after]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"scheduledTo[before]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"scheduledTo[strictly_before]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"scheduledTo[after]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"scheduledTo[strictly_after]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"deletedAt[before]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"deletedAt[strictly_before]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"deletedAt[after]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false},{"name":"deletedAt[strictly_after]","in":"query","description":"","required":false,"deprecated":false,"schema":{"type":"string"},"style":"form","explode":false}]}}}}
```

## Retrieve a product

> Retrieve a product

```json
{"openapi":"3.1.0","info":{"title":"Glu","version":"1.0.0"},"tags":[{"name":"Product","description":"Resource 'Product' operations."}],"servers":[{"url":"https://api.glu.io","description":"Production API"}],"security":[{"x_api_key":[]}],"components":{"securitySchemes":{"x_api_key":{"type":"apiKey","description":"Value for the x-api-key header parameter.","name":"x-api-key","in":"header"}},"schemas":{"Product-product.read":{"type":"object","properties":{"id":{"readOnly":true,"type":"integer"},"uuid":{"type":"string","format":"uuid"},"name":{"type":"string"},"type":{"type":"string","enum":["Voucher","Physical","RecurringProduct","ReferralProgram"]},"createdAt":{"type":"string","format":"date-time"},"updatedAt":{"type":"string","format":"date-time"},"description":{"default":"","type":["string","null"]},"status":{"default":"Active","type":"string","enum":["Draft","Active","Scheduled","Expired","Deleted"]},"permalink":{"type":"string"},"images":{"type":"array","items":{"type":["string","null"]}},"store":{"type":"integer"},"productTypePhysical":{"anyOf":[{"$ref":"#/components/schemas/ProductTypePhysical-product.read"},{"type":"null"}]},"voucher":{"anyOf":[{"$ref":"#/components/schemas/Voucher-product.read"},{"type":"null"}]},"referralProgram":{"type":["string","null"],"format":"iri-reference"},"productConfigurableOptions":{"type":"array","items":{"$ref":"#/components/schemas/ProductConfigurableOption-product.read"}},"PriceSuffix":{"default":"","type":"string"},"bundle":{"anyOf":[{"$ref":"#/components/schemas/Bundle-product.read"},{"type":"null"}]},"scheduledFrom":{"type":["string","null"],"format":"date-time"},"scheduledTo":{"type":["string","null"],"format":"date-time"},"codes":{"type":"array","items":{"$ref":"#/components/schemas/Code-product.read"}},"variants":{"type":"array","items":{"type":"integer"}},"deleted":{"default":false,"type":"boolean"},"deletedAt":{"type":["string","null"],"format":"date-time"},"location":{"type":"array","items":{"$ref":"#/components/schemas/Location-product.read"}},"allLocations":{"default":true,"type":"boolean"},"visibility":{"default":"Public","type":"string","enum":["Public","Direct Link"]},"recurringProduct":{"anyOf":[{"$ref":"#/components/schemas/RecurringProduct-product.read"},{"type":"null"}]},"productCategories":{"type":"array","items":{"$ref":"#/components/schemas/ProductCategory-product.read"}},"minimumPricing":{"type":"array","items":{"$ref":"#/components/schemas/ProductMinimumPrice-product.read"}}}},"ProductTypePhysical-product.read":{"type":"object"},"Voucher-product.read":{"type":"object"},"ProductConfigurableOption-product.read":{"type":"object"},"Bundle-product.read":{"type":"object"},"Code-product.read":{"type":"object"},"Location-product.read":{"type":"object"},"RecurringProduct-product.read":{"type":"object"},"ProductCategory-product.read":{"type":"object"},"ProductMinimumPrice-product.read":{"type":"object"},"Error.jsonld":{"type":"object","description":"A representation of common errors.","properties":{"title":{"readOnly":true,"description":"A short, human-readable summary of the problem.","type":["string","null"]},"detail":{"readOnly":true,"description":"A human-readable explanation specific to this occurrence of the problem.","type":["string","null"]},"status":{"type":["number","null"],"default":400},"instance":{"readOnly":true,"description":"A URI reference that identifies the specific occurrence of the problem. It may or may not yield further information if dereferenced.","type":["string","null"]},"type":{"readOnly":true,"description":"A URI reference that identifies the problem type","type":"string"},"description":{"readOnly":true,"type":["string","null"]}}},"Error":{"type":"object","description":"A representation of common errors.","properties":{"title":{"readOnly":true,"description":"A short, human-readable summary of the problem.","type":["string","null"]},"detail":{"readOnly":true,"description":"A human-readable explanation specific to this occurrence of the problem.","type":["string","null"]},"status":{"type":["number","null"],"default":400},"instance":{"readOnly":true,"description":"A URI reference that identifies the specific occurrence of the problem. It may or may not yield further information if dereferenced.","type":["string","null"]},"type":{"readOnly":true,"description":"A URI reference that identifies the problem type","type":"string"}}}}},"paths":{"/products/{id}":{"get":{"operationId":"api_products_id_get","tags":["Product"],"responses":{"200":{"description":"Product resource","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Product-product.read"}}}},"403":{"description":"Forbidden","content":{"application/ld+json":{"schema":{"$ref":"#/components/schemas/Error.jsonld"}},"application/problem+json":{"schema":{"$ref":"#/components/schemas/Error"}},"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"links":{}},"404":{"description":"Not found","content":{"application/ld+json":{"schema":{"$ref":"#/components/schemas/Error.jsonld"}},"application/problem+json":{"schema":{"$ref":"#/components/schemas/Error"}},"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"links":{}}},"summary":"Retrieve a product","description":"Retrieve a product","parameters":[{"name":"id","in":"path","description":"Product identifier","required":true,"deprecated":false,"schema":{"type":"string"},"style":"simple","explode":false}]}}}}
```

## List all variants for a product

> Returns a list of variants for a given product, including their pricing and selected options.

```json
{"openapi":"3.1.0","info":{"title":"Glu","version":"1.0.0"},"tags":[{"name":"Product","description":"Resource 'Product' operations."}],"servers":[{"url":"https://api.glu.io","description":"Production API"}],"security":[{"x_api_key":[]}],"components":{"securitySchemes":{"x_api_key":{"type":"apiKey","description":"Value for the x-api-key header parameter.","name":"x-api-key","in":"header"}},"schemas":{"ProductVariant-variant.read":{"type":"object","properties":{"id":{"readOnly":true,"type":"integer"},"createdAt":{"type":"string","format":"date-time"},"updatedAt":{"type":"string","format":"date-time"},"selectedOptions":{"type":"array","items":{"$ref":"#/components/schemas/ProductConfigurableOptionValue-variant.read"}},"pricing":{"type":"array","items":{"$ref":"#/components/schemas/ProductVariantPricing-variant.read"}},"deleted":{"default":false,"type":"boolean"},"deletedAt":{"type":["string","null"],"format":"date-time"},"stockQuantity":{"type":["integer","null"]},"chargeTax":{"default":true,"type":"boolean"}}},"ProductConfigurableOptionValue-variant.read":{"type":"object","properties":{"id":{"readOnly":true,"type":"integer"},"product_configurable_option":{"$ref":"#/components/schemas/ProductConfigurableOption-variant.read"},"name":{"type":"string"}}},"ProductConfigurableOption-variant.read":{"type":"object","properties":{"id":{"readOnly":true,"type":"integer"},"name":{"type":"string"}}},"ProductVariantPricing-variant.read":{"type":"object","properties":{"id":{"readOnly":true,"type":"integer"},"price":{"type":"integer"},"storeCurrency":{"$ref":"#/components/schemas/StoreCurrency-variant.read"}}},"StoreCurrency-variant.read":{"type":"object","properties":{"id":{"readOnly":true,"type":"integer"},"currencyCode":{"type":"string"}}},"Error.jsonld":{"type":"object","description":"A representation of common errors.","properties":{"title":{"readOnly":true,"description":"A short, human-readable summary of the problem.","type":["string","null"]},"detail":{"readOnly":true,"description":"A human-readable explanation specific to this occurrence of the problem.","type":["string","null"]},"status":{"type":["number","null"],"default":400},"instance":{"readOnly":true,"description":"A URI reference that identifies the specific occurrence of the problem. It may or may not yield further information if dereferenced.","type":["string","null"]},"type":{"readOnly":true,"description":"A URI reference that identifies the problem type","type":"string"},"description":{"readOnly":true,"type":["string","null"]}}},"Error":{"type":"object","description":"A representation of common errors.","properties":{"title":{"readOnly":true,"description":"A short, human-readable summary of the problem.","type":["string","null"]},"detail":{"readOnly":true,"description":"A human-readable explanation specific to this occurrence of the problem.","type":["string","null"]},"status":{"type":["number","null"],"default":400},"instance":{"readOnly":true,"description":"A URI reference that identifies the specific occurrence of the problem. It may or may not yield further information if dereferenced.","type":["string","null"]},"type":{"readOnly":true,"description":"A URI reference that identifies the problem type","type":"string"}}}}},"paths":{"/products/{productId}/variants":{"get":{"operationId":"api_products_productIdvariants_get_collection","tags":["Product"],"responses":{"200":{"description":"ProductVariant collection","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ProductVariant-variant.read"}}}}},"403":{"description":"Forbidden","content":{"application/ld+json":{"schema":{"$ref":"#/components/schemas/Error.jsonld"}},"application/problem+json":{"schema":{"$ref":"#/components/schemas/Error"}},"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"links":{}}},"summary":"List all variants for a product","description":"Returns a list of variants for a given product, including their pricing and selected options.","parameters":[{"name":"productId","in":"path","description":"Product identifier","required":true,"deprecated":false,"schema":{"type":"string"},"style":"simple","explode":false},{"name":"page","in":"query","description":"The collection page number","required":false,"deprecated":false,"schema":{"type":"integer","default":1},"style":"form","explode":true}]}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://glu.gitbook.io/docs/api-reference/organisation-api/product.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
